<template>
  <div>
    <!-- <vue-good-table
      :columns="columns"
      :rows="sortedPayments"
      styleClass="table table-hover"/> -->
      <b-table striped hover :items="sortedPayments" :fields="fields">
          <span slot="status_label" slot-scope="data" v-html="data.value"></span>
        <template slot="actions" slot-scope="row">
        <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->
       <b-button size="sm" @click.stop="info(row.item, row.index, $event.target)" class="mr-1">
          Info modal
        </b-button>
        <b-button size="sm" >
         Sửa
        </b-button>
      </template>       
      </b-table>
        <b-modal id="modalInfo" @hide="resetModal" :title="modalInfo.title" ok-only>
      <pre>{{ modalInfo.agency.name }}</pre>
    </b-modal>
  </div>

</template>

<script>
export default {
    name: 'my-component',
    data() {
        return {
            fields: [{
                    key: 'id',
                    label: 'Mã DG',
                    sortable: true
                },
                {
                    key: 'agency.name',
                    label: 'Tên đại lý',
                    sortable: true
                },
                {
                    key: 'user.name',
                    label: 'Nhân viên GD',
                    sortable: true,
                    // Variant applies to the whole column, including the header and footer
                    // variant: 'danger'
                },
                {
                    key: 'amount',
                    label: 'Số tiền',
                    sortable: true,
                    formatter: (value) => {
                        return Comma(value)
                    }
                },
                {
                    key: 'status_label',
                    label: 'Trạng thái',
                    sortable: true,

                },
                {
                    key: 'created_at',
                    label: 'Ngày tạo',
                    sortable: true,
                    formatter: (value) => {
                        return moment(value).format('DD/MM/YYYY HH:MM:SS')
                    }

                },
                {
                    key: 'actions',
                    label: 'Actions'
                }
            ],
            payments: [

            ],
            modalInfo: { title: '', agency: {} }
        };
    },
    created() {
        this.fetchPayments();
        this.listenForChanges();
    },
    methods: {
        fetchPayments() {
            axios.get('/api/payment/live').then((response) => {
                this.payments = response.data;
            })
        },
        listenForChanges() {
            Echo.channel('payment-created')
                .listen('PaymentCreated', (e) => {
               
                    var payment = this.payments.find((payment) => payment.id === e.payment.id);
                    // check if payment exist on table
                    if (payment) {
                        var index = this.payments.indexOf(payment);
                        this.payments[index].amount = e.amount;
                    }
                    // if not, add payment
                    else {
                        this.payments.push(e.payment)
                    }
                })
        },
        info(item, index, button) {
            this.modalInfo.title = `Row index: ${index}`
            this.modalInfo.agency = item.agency;
            this.$root.$emit('bv::show::modal', 'modalInfo', button)
        },
        resetModal() {
            this.modalInfo.title = ''
            this.modalInfo.content = ''
        },

    },
    computed: {
        sortedPayments() {
            return this.payments.sort((a, b) => new Date(b.created_at) - new Date(a.created_at))
        }
    }
};
</script>